(* opg 2.7 *)
fun notDivisible( d, n ) = not (n mod d = 0); 

(* a: *)
fun test (a,b,c) =
    if a<b then notDivisible(a,c) andalso test(a+1, b, c)
    else notDivisible(b, c);

(* b: *)
fun prime(2) = true
    | prime(n) = test(2,n-1,n);

(* c: *)
fun isEven(n) = (n mod 2 = 0);


local

fun findNextPrime(n) =
    if prime(n) then n
    else findNextPrime(n+2);

in

fun nextPrime(1) = 2
 |  nextPrime(n) = 
    if isEven(n) then findNextPrime(n+1) 
    else findNextPrime(n+2);

end

(* opg 3.3 *)
(* a: *)
infix 6 ++
infix 7 **


fun (a:real, b:real) ++ (c:real,d:real) = (a+c,b+d);
fun (a:real, b:real) ** (c:real,d:real) = (a*c-b*d, b*c+a*d);

(* b: *)
infix 6 --
infix 7 //

fun (a:real,b:real) -- (c:real,d:real) = (a,b) ++ (~c,~d);
fun (a:real,b:real) // (c:real,d:real) = (a,b) ** ( c/(c*c+d*d), ~d/(c*c+d*d) );
fun knep() = true;

(* c: *)
exception divbyzero

fun (a:real,b:real) // (c:real,d:real) = 
    let val g:real = c*c+d*d in
    if g=0.0 then raise divbyzero 
    else ((a*c+b*d)/g,(c*b-a*d)/g)
    end;

load "Real";

fun toString(a,b) = Real.toString(a)^"+"^Real.toString(b)^"i";

(* opg 4.3 *)
(*

Interface definition:
Specification                                       Comment

type complex = real * real                          Complex numbers
exeption divbyzero                                  Division by zero
++ (real * real) * (real * real) -> real * real     add complex numbers
** (real * real) * (real * real) -> real * real     multiply complex numbers
--  (real * real) * (real * real) -> real * real    subtract complex numbers
//  (real * real) * (real * real) -> real * real    divide complex numbers
toString (real * real) -> string                    string representation of complex numbers



Test cases:
Case    function    Input                  Expected result                    Remark
1       ++          (5.0,2.0)++(7.0,9.0)   (12.00,11.00)
2       --          (5.0,2.0)--(7.0,9.0)   (~2.0,~7.0) 
3       **          (5.0,2.0)**(7.0,9.0)   (17.0, 59.0)
4       //          (5.0,2.0)//(7.0,9.0)   (0.4076, ~0.2384)
5       //          (5.0,2.0)//(0.0,0.0)   Uncaught exception:  divbyzero    Division by zero
6       toString    toString(5.0,2.0)      "5.0+2.0i"      


*)


