(* opg 6.3 *)
(* a: *)
type country = string;
type neighbour = (country*country);
type neighbourRelation = neighbour list;
type color = country list;
type coloring = color list;

(* her defineres prvedata *)
(* val test = [ ("D", "jylland"), ("DK", "S"), ("S", "N"), ("DK", "jylland") , ("S", "F"), ("N", "F"), ("DK", "D"), ("TYRKIET", "KORSIKA"), ("TYRKIET", "jylland"), ("KORSIKA", "ITALIEN"), ("ITALIEN", "TYRKIET") ]; *)
 val test = [ ("A", "B"), ("A", "C"), ("A", "D"), ("B", "C"), ("B", "D"), ("C", "D"), ("E", "A"), ("E","B"), ("E", "D"), ("A", "A")];
(* end def *)

(* b: *)
infix 0  memberOf


fun _ memberOf []  = false
 |  a memberOf (e::el) =
    if (a=e) then true
    else a memberOf( el );

(* neighbour * neighbourRelation -> bool, true hvis c1 er nabo til c2 (dvs. c1 * c2 findes i nr eller c2 * c1 findes i nr) *)
fun isNeighbour( (c1,c2):neighbour, nr:neighbourRelation) =
 if ((c1,c2) memberOf nr) orelse ((c2,c1) memberOf nr) then true
 else false;
  
(* c: *)
(* neighbourRelation * country * color -> bool , true if country can be added to color *)
fun canExtend ( nr:neighbourRelation, co:country, [] ) = true 
 |  canExtend ( nr:neighbourRelation, co:country, cn::cl : color) = 
       not(isNeighbour( (cn, co), nr )) andalso canExtend(nr, co, cl );

(* d: *)
(* hvis canextend farven sa tilfoj land til farve ellers prov ny farve. hvis ingen farver tilbage, returner ny farve
   neighbourRelation * coloring * country -> coloring *)
fun addCTC ( _, [], co ) = [[co]]
 |  addCTC (nr:neighbourRelation, (col::colors):coloring, co:country ) = 
    if co memberOf col then col::colors else
    if canExtend(nr, co, col) then (co::col) :: colors
    else col::addCTC(nr,colors,co);

(* e: *)
(* neighbourRelation * neighbourRelation * coloring -> coloring,
   for hvert element i nr tilfjes de to lande til farvelgningen og resultatet returneres *)
fun colorMapList ( _, [], cl) = cl
 |  colorMapList ( nr0:neighbourRelation, (c1,c2)::nr:neighbourRelation, cl:coloring) = 
    colorMapList( nr0, nr, addCTC( nr0, addCTC(nr0, cl, c2), c1) );
    
(* neighbourRelation -> coloring, "dummy"-funktion til colorMapList, srger for korrekt input i colorMapList *)
fun colorMap ( [] ) = []
 |  colorMap (nr:neighbourRelation) = colorMapList( nr, nr, [] );


(* f: *)
(*
Interface definition, se ved de enkelte funktioner!


Test cases: ("test" er defineret)
Case    Funktion            Branch                                Remark
 1      isNeighbour         (("", ""), test)                      returns false 
 2      isNeighbour         (("A", "B"), test)                    returns true
 3      canExtend           (test, "A", (["B"]))                  returns false (A og B er jo naboer)
 4      canExtend           (test, "C", (["E"]))                  returns true (C og E er jo ikke naboer)
 5      addCTC              (test, ["E"], "B")                    returns [["E"], ["B"]]
 6      addCTC              (test, [["E"], ["B"]], "D")           returns [["E"], ["B"], ["D"]]
 7      colorMapList        (test, test, [["E"], ["B"]])          returns [["C", "E"], ["B"], ["A"], ["D"]]
 8      colorMapList        (test, [], [["E"], ["B"]])            returns [["E"], ["B"]]
 9      colorMap            ([])                                  returns []
10      colorMap            (test)                                returns [["B"], ["A"], ["E", "C"], ["D"]]


Tests:
Test     Case      Test              Expected result
1        9         colorMap([])      []
2        1-8+10    colorMap(test)    [["B"], ["A"], ["E", "C"], ["D"]]       
*)

(* g: *)
(* nothing happens, apart from whats supposed to happen, ie. the dubble-added countries
   are only added once; "test = ("A", "A")" :

 colorMap(test);
> val it = [["B"], ["A"], ["E", "C"], ["D"]] : string list list
*)




