datatype 'a Tree = Leaf | Node of 'a * 'a Tree * 'a Tree;

fun insert comp (s, Leaf) = Node( s, Leaf, Leaf )
  | insert comp (s, Node(a,l,r)) = case comp(s,a) of
                                  GREATER => Node(a,l,insert comp (s, r ))
				| EQUAL => Node(a,l,r)
				| LESS => Node(a,insert comp (s, l),r);

fun ListToTree comp ( s::sl ) = insert comp (s, ListToTree comp (sl))
 |  ListToTree comp ( [] ) = Leaf;

fun foldTree f e Leaf = e
 |  foldTree f e (Node(s,l,r)) = f(s, foldTree f e l, foldTree f e r);

fun inOrder(t) = foldTree (fn (s,ll,rl) => ll @ [s] @ rl) [] t; 

fun preOrder(t) = foldTree (fn (s,ll,rl) => [s] @ ll @ rl) [] t;

fun postOrder(t) = foldTree (fn (s,ll,rl) => ll @  rl @ [s]) [] t;

fun sort comp (l) = inOrder( ListToTree comp (l) );

fun dontRemove opt (a,b) = case opt(a,b) of
                     GREATER => GREATER
                   | LESS => LESS
                   | EQUAL => LESS;


fun genList _ (0) = []
 |  genList generator (n) = generator :: (genList generator (n-1)); 


val ls = ["hej","ned","op","nitte", "stasser","abekat","plader","higher-order-functions","stinker","lugter"];

load "Random";

val lr = Random.randomlist(50, Random.newgen () );

val li = Random.rangelist (0,100) (50, Random.newgen () );


