signature Curves =
sig

type point = real * real
type curve

val Point: point -> curve
val Line: point*point -> curve
val Join: curve*curve -> curve
val Trans: curve*point -> curve
val Rot: curve*real -> curve
val Scale: curve*real -> curve
val ReflectX: curve -> curve
val ReflectY: curve -> curve
val SizeX: curve -> real
val SizeY: curve -> real
val Hilbert: curve -> curve
val Sierpinski: curve -> curve
val SmartRec: (curve -> curve) -> int -> curve
val realToString: real -> string
val Draw: curve -> string
val toPostscript: string * string -> unit
val curveToPostscript: curve *string -> unit
val DrawOneCurve: (curve -> curve) -> int*string -> unit

end




